
/* Copyright (c) Mark Steven Davis (G0KHB), 1998-2002.

=========================================================================

SEARCH PATTERNS:

{cfg}|{var}|{mac}|{src}|{fil}rec

=========================================================================

CHANGE RECORD:

20020410 MSD027 While version 1.2.002 of CFG2 *would* build and run under
1.2.041         LINUX / GCC, it didn't build *cleanly*.  Hence this attempt
                to reduce the number of warnings produced by TC *and* GCC to
                zero.  As a result, some things crawled out of the woodwork:

                (a) Corrected the typo in the definition of REPORTRTS() -
                    the "vpod" text *should* have been "void", of course.

                (b) Corrected invocation of FINDMAC() in the function
                    EXPANDSTRING().  The returned result wasn't being
                    treated as a BOOL.  (That is, I deleted the "!= NULL"
                    text.)

                (c) Stop the program generating the "Cannot find switchELF"
                    message when used with no parameters under LINUX - CFG2
                    now *always* uses a .INI extension when biulding the
                    default CFG2 source file name that is based upon the
                    CFG2 executable name.

20010311 MSD026 As a result of adopting the new version numbering scheme, we
1.2.002         now have each development directory containing a "C" source
                header with a single definition of PVERSION in it.  I have
                altered each utility's documentation to do a CFG2 #INCLUD of
                this file.  Hence, each file can tell you to which version
                of the utitlity it refers.  However, I want to be able to
                make the web site source tell the users which is the latest
                of *each* utility.  It can, of course, include each
                VERSION.INI file in turn *but*, before this modification,
                only a #REDEF could *alter* the value of a macro.
                Therefore, this mod has relaxed the rules for using #DEFINE
                to *alter* a macro - you can do this now but CFG2 will issue
                a warning if you do.  (#REDEF, of course, remains as
                before.)

20010311 MSD025 Adopt the new "standard" format for VERSION.H so that the web
1.1.222         site can automatically generate a list of current program
                version numbers.

20010306 MSD024 Use STRNCPY() instead of STRCPY() in EXTRACTNEXTID() to safe
1.1.204         guard against over-length tag names.  (This should cure the
                bug whereby a long, unbroken string of non-space characters
                at the start of a script line causes a stack overflow.)

20010227 MSD023 Added function DESTROYLISTS() and call to ATEXIT() in order
1.1.199         to destroy all of the lists at program termination.  (Up
                until now, I'd been relying on the operating system's "make
                everything nice" processing that it'd do for *all* processes
                run.  It strikes me that this may not be a good idea under
                any Microsnot operating systems...)

20010219 MSD022 (a) Added the JUSTONE operator.
1.1.188         (b) Double under-line escapement.  (Hence, a trailing "__" would
                    place a trailing under-line as the last character in the
                    line.)

20010216 MSD021 Added the XOR operator.

20010216 MSD020 Slightly altered the order in which items are tested for a match
                to the current "pattern" in EXPANDSTRING().  In fact, I moved
                the test for a match against the set of currently declared files
                nearer the end of the function so that it is in the same place
                as the test for a match against a macro name or switch name.

20010215 MSD019 Altered the call to SHOWSWITCHES() in DODUMPWORD() to
                display *all* switches rather than just the currently "set"
                switches.

20010214 MSD018 (a) Allow a zero margin for when the "line expressions"
                    aren't required.
                (b) Added a line that, when "verbose" mode is enabled, displays
                    the text about to be sent to all active files.

20010213 MSD017 Added SHOWUSAGE() which is called if there are no
                command-line parameters and no .INI file can be found.

20010211 MSD016 Fixed a trivial, yet annoying, bug concerned with the
                handling of comments. I altered my web-site generation suite
                to *enable* the passing through of blank lines so that the
                generated HTML was a bit more lucid when viewing the HTML
                with a text editor.  When I did this, I noticed a small
                problem - every comment line read when file output was being
                generated resulted in a blank line in the out file(s).  The
                problem is that after comment-stripping, a line that only
                contains a comment looks just like a *blank* line and,
                hence, CFG2 generates a blank line in the output files.  In
                order to fix this, I've altered STRIPCOMMENT() so that it
                returns, not a characters pointer, but a Boolean that
                indicates whether the *entire* line was a comment.  Then,
                GENERATEFILES() can short-circuit the parsing of a line that
                *is* all comment.

20010209 MSD015 Added use of the dinky new "list handler".  This turned out
                to be a bit of a struggle.  Using the old array-of-records
                approach, one could keep one's place in the array merely by
                using a simple integer index into the array. However, this
                is no longer true as the "current record" pointer is held,
                on a per-list basis, within the list handler. As a result,
                one part of the program can mess up another's access by
                merely looking up something in one of the lists. Therefore,
                a couple of functions have to do extra lookups to
                "re-position" themselves after something *else* has been
                farting around.

                In addition, I had to add a few lines to increase the stack
                size; even though local (stacked) instances of the records
                in the lists have been kept to a minimum, I *still* had to
                make the stack bigger. In the event, I also added a function
                that would report on the state and size of the stack and the
                amount of free heap.

20010209 MSD014 Added -T, "source tracing", switch.  When enabled, this will
                print each source line as it is read.  (Automatically enabled
                when debugging is enabled but *not* when verbose mode is
                enabled.)

20010207 MSD013 Using a switch's name between macro expansion characters now
                results in the switch's name being replaced by the switch's
                *value*.  Hence, one can do this:

                #switch S
                #say Switch S is now %S%.

20010207 MSD012 Major changes to the way that the Boolean stacks are
                handled.  Now, there's none of this "pushing an item at the
                start in case of underflow" business.  It's now done
                *properly*...  (Not flagged because the changes are extensive.)

20010206 MSD011 (a) Make the large local strings STATICs to save stack
                    space. Also, changed model from "small" to "large". (The
                    latter change, of course, is actually carried out in the
                    .MAK file.)
                (b) Note that all modification records have been removed due
                    to large changes in the source.
                (c) I have *removed* the "reminder" ('-?' or '?') facility.
                    It's now much more difficult to implement and I never *use*
                    it.

20010206 MSD010 Invoke DOPARAMS() from MAIN() *and* EVALUATE(). The trouble
                is that DOPARAMS() has to apply command-line switch
                settings, and so on, *before* the first evaluation of any
                "expressions".  Since adopting Mr Edmunds' "if-else-endif
                takes priority" mode, we have to make sure all switches are
                set to their correct value *before* the first evaluation
                takes place.  (With the old scheme, if-else-endif constructs
                were essentially *ignored* during the first pass and the
                *whole* source scanned.  Hence, no evaulations were done and
                at the end of the first pass, *all* switches were gathered
                in and set to their correct values.)  Note that #SETs and the
                like *also* have to first the command-line to be processed.
                We have, here, abandoned the multi-pass system - CFG2 now
                does all it's processing in a single pass.

20010206 MSD009 Alter the #DUMP word to print out which pass we're on.

20010206 MSD008 Added special macro names for generating the numeric forms of
                date and time and a version that generates a combination of the
                two.

20010205 MSD007 Added wildcarding to #SEND, #READ and #INCLUD.  Thus one can
                now do, for example, "#SEND HTML*", "#CLOSE HTML*",
                "#DELETE HTML*" and so on.

20010205 MSD006 (a) Added VERSION.H stuff.
                (b) Various farting around to adopt Eddie's changes in a
                    "proper" manner.

0.9z: (Hijacked by ME)
ME005
Fix breaking #dump word.  Note that #dumps will now look different
because the file commands are now not parsed on the first pass.

0.9y: (Hijacked by ME)
This change has several parts.
Everything has been #ifdef ME to show the changes.

ME004
Fix lowercase variables so that they gets parsed correctly.
   #say    Generating program is: %cfg2progname%
Would actually say "Generating program is: ".

ME003
Better handling of null definitions.

ME002
New #RDRUN command which runs a command and sends the output to the
current #SEND files.  This basically hides sending to a temporary file.

ME001
Changed logic of DoSpecial so that #IF-#ELSE-#ENDIF words override
everything including switches and configs.  I don't think this
change will affect any existing INI files?

0.9x:

Corrected a bug in the handling of OR_OP.  In EVALUATE(), the following code
was incorrect:

        if      ( IsSame(NextExpr,OR_OP) )
                PushStack( &S, PopStack(&S) || PopStack(&S) );

If the first OPOSTACK() returns TRUE, the second isn't executed.  ("C"
short-circuits the evaluation of the logical "or" operator if the first half
of the expression is TRUE since, by then, it knows that the whole expression
is TRUE.)

This argument applied equally well to the handling of AND_OP, of course.

0.9w:

Removed a couple of un-used local variables.  Also, increased the number of
macros from 16 to 32.

0.9u/0.9v:

Added #REDEF and associated code.

0.9t:

Re-organise DOSPECIAL() so that #IF-#ELSE-#ENDIF words over-ride *all*
special words.  (Hence, one can now do #IF-#DEFINE-#ELSE-#DEFINE-#ENDIF and
have it work as one would expect.)  Changes not flagged - the handling of
the conditional words and the call to PEEKSTACK() have just been moved from
after the handling of DUMP_WORD to a point after STRIPTRAILCHAR() is called.

0.9s:

Changed maximum line length from 256 to 512 characters so that I can
generate PRACTICAL.MAK in its "native" format before prettying it up by using
CFG2.

0.9r:

Added source file inclusion facilities.

0.9q:

Add #DEFINE word and macro facilities.

0.9p:

Fixed the positioning of the call of DOREADWORD() in DOSPECIAL().  When I
added this call, I placed it too soon in the calling function and, as a
result, if would *always* be executed even if it was between a non-selected
#IF/#ENDIF pair.

0.9o:

Make configuration source .INI file available as "macro" %CFG2SOURCE%.

CFG2 will now automatically append the file extension if it can't open a
source file.

Added the data (read-only) file facility words (#DATA and #READ).

0.9n:

Allow blank lines to be passed through unscathed by use of the #EMPTY word.

Using #SEND and #CLOSE without any parameters sends to *all* files and
closes *all* files respectively.

0.9m:

Using the "debugging" option now also causes the "verbose" option to be set.

Correct a bug whereby the line number reported in error messages wasn't
correct.  (It wasn't re-initialised after the end of the first pass through
the file.)

0.9L:

CFG2 now uses a *two* pass method to read the config files.  As a result,
switches and configs can be defined almost anywhere - switches can even be
referenced before they are *defined*.  (See CFG2.INI for an example of
this.)

As a corollary to the above, you can now use "-?" or "?" on its own to make
CFG2 print a "reminder" of the currently selectable configurations and
defined switches.

========================================================================= */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>

#if     defined(__TURBOC__)
#include <alloc.h>
#endif

#include "listhand.h"
#include "version.h"

#define STR2(x)         #x
#define STR(x)          STR2(x)
#define PROGNAME        "CFG2 " STR(PVERSION) " " __DATE__

#define STACKSIZE       0xABCDU

/* ====================================================================== */

#ifndef ZERO
#define ZERO            0
#endif
#ifndef ONE
#define ONE             1
#endif
#ifndef TWO
#define TWO             2
#endif
#ifndef FALSE
#define FALSE           ZERO
#endif
#ifndef TRUE
#define TRUE            ( !FALSE )
#endif
#ifndef BOOL
#define BOOL            int
#endif

#define EOS             '\0'
#define CR              '\r'
#define SPACE           ' '
#define LF              '\n'
#define TAB             '\t'
#define FF              '\f'
#define DOT             '.'

#define NILSTR          ""
#define SPACESTR        " "

/* DIR is the local character that delimits directory names within a
 * fully-qualified file name.  For example, on UNIX this is'/' whereas under
 * MS-DOS this is '\'.
 */

#if     defined(__unix__)
#define DIR             '/'
#else
#define DIR             '\\'
#endif

/*--------------------------------------------------------------------------*/

#define MAX_LINE_LEN    512
#define MAX_PATH_LEN    256
#define MAX_ID_LEN      32
#define MAX_EXPR_STACK  16

#define SOURCE_EXT      ".ini"

#define ALWAYS_CONFIG   "ALWAYS"
#define DEFAULT_CONFIG  "DEFAULT"
#define EXPAND_PROGNAME "CFG2PROGNAME"
#define EXPAND_PARAMS   "CFG2PARAMS"
#define EXPAND_SWITCHES "CFG2SWITCHES"
#define EXPAND_SOURCE   "CFG2SOURCE"
#define EXPAND_DATIM    "CFG2DATIM"
#define EXPAND_DATE     "CFG2DATE"
#define EXPAND_TIME     "CFG2TIME"

#define DEFAULT_MARGIN  8
#define DEFAULT_TAB     DEFAULT_MARGIN
#define DEFAULT_VERBOSE 0
#define DEFAULT_PASSEMPTY 0

#define COMMENT_CHAR    ';'
#define NO_CRLF_CHAR    '_'
#define EMPTY_LINE_CHAR '_'
#define EXPAND_CHAR     "%"
#define OPTION_STR      "-/"
#define WILD_ONE_CHAR   '?'
#define WILD_MANY_CHAR  '*'

#define IF_WORD         "#IF"           /* If you change these words, check */
#define ELSE_WORD       "#ELSE"         /* SPECIALWORDS[], below, in case   */
#define ENDIF_WORD      "#ENDIF"        /* change are necessary *there*.    */
#define FILE_WORD       "#FILE"
#define DATA_WORD       "#DATA"
#define READ_WORD       "#READ"
#define SRC_WORD        "#SOURCE"
#define INC_WORD        "#INCLUD"
#define CLOSE_WORD      "#CLOSE"
#define DELETE_WORD     "#DELETE"
#define RUN_WORD        "#RUN"
#define RDRUN_WORD      "#RDRUN"
#define VAR_WORD        "#SWITCH"
#define CFG_WORD        "#CONFIG"
#define DEFINE_WORD     "#DEFINE"
#define REDEF_WORD      "#REDEF"
#define SET_WORD        "#SET"
#define SHOW_WORD       "#SHOW"
#define DUMP_WORD       "#DUMP"
#define ERROR_WORD      "#ERROR"
#define SAY_WORD        "#SAY"
#define SEND_WORD       "#SEND"
#define MAR_WORD        "#MARGIN"
#define TAB_WORD        "#TAB"
#define EMPTY_WORD      "#EMPTY"

#define SAME_AS_BEFORE  "="

#define AND_OP          "&"
#define OR_OP           "|"
#define NOT_OP          "!"
#define XOR_OP          "^"
#define JUSTONE_OP      "JUSTONE"

#define CFG_NAME_OPTION 'F'
#define PATH_OPTION     'P'
#define DEBUG_OPTION    'D'
#define TRACE_OPTION    'T'
#define VERBOSE_OPTION  'V'
#define HELP_OPTION     'H'
#define DUMP_OPTION     '?'

#define EMPTY_PARAMS    "-none-"

/* ====================================================================== */

#define OUTPUT_FILE     0
#define INPUT_FILE      1
#define SOURCE_FILE     2

typedef char    Tag[MAX_ID_LEN+ONE];

typedef char    FName[MAX_PATH_LEN+ONE];

/*--------------------------------------------------------------------------*/

typedef struct
        {
                Tag     Id;
                char    List[MAX_LINE_LEN+ONE];
        }       CfgRec;

typedef struct
        {
                BOOL    Value;
                Tag     Id;
                char    Expr[MAX_LINE_LEN+ONE];
        }       VarRec;

typedef struct
        {
                Tag     Id;
                char    Text[MAX_LINE_LEN+ONE];
        }       MacRec;

typedef struct
        {
                long    LNum;
                FILE    *Hand;
                char    Name[MAX_LINE_LEN+ONE];
        }       SrcRec;

typedef struct
        {
                BOOL    Open;           /* Is file open? */
                BOOL    Trunc;          /* Need to truncate it? */
                BOOL    Used;           /* In use? */
                BOOL    CRLF;           /* Had CRLF on previous line? */
                BOOL    Type;           /* Filetype: output, input or source. */
                FILE    *Hand;
                Tag     Id;
                FName   Name;
        }       FilRec;

/* ====================================================================== */

char    *SpecialWords[] =
{
IF_WORD,    "%-10s <expression>          Starts the conditional construct.\n",
ELSE_WORD,  "%-10s                       Begins second part of conditional.\n",
ENDIF_WORD, "%-10s                       Terminates a conditional.\n",
FILE_WORD,  "%-10s <filetag> <filename>  Declares an output file.\n",
DATA_WORD,  "%-10s <filetag> <filename>  Declares an input raw data file.\n",
READ_WORD,  "%-10s <filetag>             Reads a raw data file.\n",
SRC_WORD,   "%-10s <filetag> <filename>  Declares a source file.\n",
INC_WORD,   "%-10s <filetag>             Includes a source file.\n",
CLOSE_WORD, "%-10s <filetag>             Closes the specified file.\n",
DELETE_WORD,"%-10s <filetag>             Deletes the required file.\n",
RUN_WORD,   "%-10s <command-line>        Executes the given command line.\n",
RDRUN_WORD, "%-10s <command-line>        Executes command capturing stdout.\n",
VAR_WORD,   "%-10s <tag> [<expression>]  Defines a simple or derived switch.\n",
CFG_WORD,   "%-10s <tag> <taglist>       Creates a 'configuration' switch.\n",
DEFINE_WORD,"%-10s <tag> <string>        Creates a macro definition.\n",
REDEF_WORD, "%-10s <tag> <string>        Alters a macro definition.\n",
SET_WORD,   "%-10s <taglist>             The named tags are set as required.\n",
SHOW_WORD,  "%-10s                       Show the current switch status.\n",
DUMP_WORD,  "%-10s                       Diagnostic switch and file tag dump.\n",
ERROR_WORD, "%-10s <user-error-message>  Allows the generation of error messages.\n",
SAY_WORD,   "%-10s <user-message>        Allows the generation of user messages.\n",
SEND_WORD,  "%-10s <filetag>             Nominates the destination output file(s).\n",
MAR_WORD,   "%-10s <number>              Sets width of line expression area.\n",
TAB_WORD,   "%-10s <number>              Tabs are expanded to specified width.\n",
EMPTY_WORD, "%-10s <expression>          Passes empty lines unchanged if true.\n",
NULL,           NULL
};

/* ====================================================================== */

FName   PathName;
FName   CfgFileName;

BOOL    Debugging       = FALSE;
BOOL    Tracing         = FALSE;
BOOL    Verbose         = DEFAULT_VERBOSE;

int     MarginSetting   = DEFAULT_MARGIN;
int     TabSetting      = DEFAULT_TAB;
int     PassEmpty       = DEFAULT_PASSEMPTY;

#if     defined(__TURBOC__)
extern  unsigned _stklen = STACKSIZE;
#endif

/*------------------------------------------------------------------------*/

int     VarList;
int     MacList;
int     CfgList;
int     FilList;
int     SrcList;

/* ====================================================================== */

/* Functions in this "section" are potential trouble-makers; it seemed a
 * good idea to keep 'em all in one place...
 */

/*------------------------------------------------------------------------*/

void    RunCommand(     char    *CommandLine )
{
        int     Result;

        if ( Debugging ) printf("System command '%s'\n",CommandLine);

        Result = system(CommandLine);

        if ( Debugging ) printf("System command returns %d\n",Result);
}

/*------------------------------------------------------------------------*/

void    GetCfgFileName( char    *FileName,
                        char    **argv )
{
        char    *LastDir;
        char    *LastDot;

        strcpy(FileName,argv[ZERO]);

        LastDir = strrchr(FileName,DIR);
        LastDot = strrchr(FileName,DOT);

        if      ( ( LastDot != NULL )
        &&        ( LastDot > LastDir ) )
                *LastDot = EOS;

        strcat(FileName,SOURCE_EXT);
}

/*------------------------------------------------------------------------*/

void    ErrorExit(      char    *Message,
                        char    *Item );

void    ReportRTS(      void )
{
#if     defined(__TURBOC__)

        printf("RTS: StackSize=%u StackAvail=%u CoreLeft=%lu\n",
                     _stklen,     stackavail(), coreleft());

        if      ( heapcheck() == _HEAPCORRUPT )
                ErrorExit("Heap corrupt!",NULL);
#endif
}

/* ====================================================================== */

char    *CurSrc(        void );

/*------------------------------------------------------------------------*/

void    ErrorExit(      char    *Message,
                        char    *Item )
{
        printf("\nError at %s: ",CurSrc());

        if      ( Item == NULL )
                printf(Message);
        else
                printf(Message,Item);

        printf("\n");

        exit(EXIT_FAILURE);
}

/*------------------------------------------------------------------------*/

void    Warning(        char    *Message,
                        char    *Item )
{
        printf("\nWarning at %s: ",CurSrc());

        if      ( Item == NULL )
                printf(Message);
        else
                printf(Message,Item);

        printf("\n");
}

/* ====================================================================== */

void    AllToUpper(     char    *s )
{
        while   ( *s )
        {
                *s = toupper(*s);
                s++;
        }
}

/*------------------------------------------------------------------------*/

BOOL    IsPresent(      char    *s )
{
        return  ( strlen(s) > ZERO );
}

BOOL    IsSame(         char    *s,
                        char    *t )
{
        return  ( strcmp(s,t) == ZERO );
}

/*------------------------------------------------------------------------*/

BOOL    IsWord(         char    *WordName,
                        char    *Text )
{
        Tag     Word;
        int     WordLen = strlen(WordName);

        strncpy(Word,Text,WordLen);
        Word[WordLen] = EOS;

        AllToUpper(Word);

        return  ( IsSame(WordName,Word) );
}

/* ====================================================================== */

/* Returns pos of char C in string S - returns -1 if it can't find C. */

int     strpos(         char    *s,
                        char    c )
{
        int i;
        int len = strlen(s);

        for     ( i=ZERO ; i<len ; i++ )
                if      ( s[i] == c )
                        return  i;
        return  -ONE;
}

/*------------------------------------------------------------------------*/

/* Replaces all occurrences of OLD with NEW in string S.  It returns the
 * number of replacesments made.
 */

int     strrep(         char    *s,
                        char    Old,
                        char    New )
{
        int Replacements = ZERO;

        while   ( *s )
        {
                if      ( *s == Old )
                {
                        *s = New;
                        Replacements++;
                }

                s++;
        }

        return  Replacements;
}

/*------------------------------------------------------------------------*/

char    *strdel(        char    *s,
                        int     pos,
                        int     num )
{
        int     len = strlen(s);

        if      ( ( len > 0 ) && ( num > 0 ) && ( pos < len ) )
                if      ( num > ( len - pos + 1 ) )     /* Then deleting to */
                        s[pos] = EOS;                   /* the end of "s".  */
                else
                        strcpy(s+pos,s+pos+num);        /* Else just copy   */
                                                        /* the rest down.   */
        return  s;
}
/*--------------------------------------------------------------------------*/

char    *strins(        char    *targ,
                        char    *src,
                        int     pos )
{
        char   *s;
        char   *t;
        int     lenT;
        int     lenS;
        int     i;

        lenT = strlen(targ);
        lenS = strlen(src);

        if      ( ( pos < 0 ) || ( lenS <= 0 ) )
                return  ( targ );

        if      ( pos >= lenT )
        {
                strcat(targ,src);
                return  ( targ );
        }

        s = targ + lenT;
        t = s + lenS;
        for( i=0; i<(lenT-pos+1); ++i ) *t-- = *s--;

        s = src;
        t = targ + pos;
        for ( i=0; i<lenS; ++i ) *t++ = *s++;

        return  ( targ );
}

/*------------------------------------------------------------------------*/

char    *StripCRLF(     char    *s )
{
        while   ( IsPresent(s)
        &&        ( ( s[strlen(s)-ONE] == CR )
          ||        ( s[strlen(s)-ONE] == LF ) ) )
                strdel(s,strlen(s)-ONE,ONE);

        return  s;
}

/*------------------------------------------------------------------------*/

char    *StripTrailChar(char    *s,
                        char    c )
{
        while   ( IsPresent(s) && ( s[strlen(s)-ONE] == c ) )
                strdel(s,strlen(s)-ONE,ONE);

        return  s;
}

/*------------------------------------------------------------------------*/

char    *StripLeadChar( char    *s,
                        char    c )
{
        while   ( IsPresent(s) && ( s[ZERO] == c ) )
                strdel(s,ZERO,ONE);

        return  s;
}

/*------------------------------------------------------------------------*/

/* Strips out comments from a line of text and returns TRUE iff the *entire*
 * line was a comment.  (That is, it returns FALSE unless the comment starts
 * at the first character in the line.)
 */

BOOL    StripComment(   char    *s )
{
        if      ( ( s[ZERO] == COMMENT_CHAR )
        &&        ( s[ONE]  != COMMENT_CHAR ) )
        {
                *s = EOS;
                return TRUE;
        }

        while   ( *s )
                if      ( *s != COMMENT_CHAR )
                        s++;
                else
                if      ( *(s+ONE) == COMMENT_CHAR )
                {
                        strdel(s,ZERO,ONE);
                        s++;
                }
                else
                        *s = EOS;
        return  FALSE;
}

/*------------------------------------------------------------------------*/

char    *ExpandTabs(    char    *s,
                        int     TabStop )
{
        char    *t = s;

        while   ( *t )
                if      ( *t != TAB )
                        t++;
                else
                {
                        *t++ = SPACE;

                        while   ( ( ( t - s ) % TabStop ) != ZERO )
                                strins(t++,SPACESTR,ZERO);
                }


        return  s;
}

/*------------------------------------------------------------------------*/

char    *StepOverSpaces(char    *s )
{
        while ( *s == SPACE ) s++;

        return  s;
}

/*------------------------------------------------------------------------*/

char    *ExtractNextId( char	*Dest,
                        char    *Text )
{
        int     Pos = strpos(Text,SPACE);
        int     Lim;
        char    *Result;

        strcpy(Dest,NILSTR);

        if ( *Text == EOS ) return NULL;

        if ( Pos < ZERO ) Pos = strlen(Text);

        Lim = ( Pos > MAX_ID_LEN ) ? MAX_ID_LEN : Pos;

        strncpy(Dest,Text,Lim);
        ((char*)Dest)[Lim] = EOS;
        AllToUpper(Dest);

        Result = StepOverSpaces(Text+Pos);

        if ( *Result == EOS ) return NULL;

        return  Result;
}

/* ====================================================================== */

static
int     strRmatch(      char    *s,
                        int     lastS,
                        int     i,
                        char    *p,
                        int     lastP,
                        int     j )
{
        int     matched;
        int     k;

        if      ( !*p )
                return ( ONE );

        for     (;;)
        {
                if      ( ( ( i > lastS ) || ( !s[i] ) )
                &&        ( ( j > lastP ) || ( !p[j] ) ) )
                        return  ( TRUE );

                if      ( ( j > lastP ) || ( !p[j] ) )
                        return  ( FALSE );

                if      ( p[j] == WILD_MANY_CHAR )
                {
                        k = i;

                        if      ( ( j == lastP ) || ( !p[j+ONE] ) )
                                return  ( TRUE );
                        else
                        {
                                do      {
                                        matched = strRmatch(s,lastS,k,
                                                                 p,lastP,j+ONE);
                                        ++k;
                                        }
                                while   ( ( !matched )
                                &&        ( k <= lastS )
                                &&        ( s[k] ) );

                                return  ( matched );
                        }
                }

                if      ( ( p[j] != WILD_ONE_CHAR )
                &&        ( p[j] != s[i] ) )
                        return  ( FALSE );

                ++i, ++j;
        }
}

int     strmatch(       char    *src,
                        char    *patt )
{
        return strRmatch(src,strlen(src)-ONE,ZERO,patt,strlen(patt)-ONE,ZERO);
}

int     iswildcard(     char    *patt )
{
        return  ( strpos(patt,WILD_ONE_CHAR) >= ZERO )
        ||      ( strpos(patt,WILD_MANY_CHAR) >= ZERO );
}

/* ====================================================================== */

BOOL    FindCfg(        char	*Id,
                        CfgRec  *Cfg )
{
        int Size = sizeof(CfgRec);

        if      ( ListFirst(CfgList) )
        do
        {
                if      ( !ListGet(CfgList,&Size,Cfg) )
                        ErrorExit("Can't retrieve macro",Id);

                if      ( Size != sizeof(CfgRec) )
                        ErrorExit("Incorrect size of config",Id);

                if ( IsSame(Id,Cfg->Id) ) return TRUE;
        }
        while   ( ListNext(CfgList) );

        return  FALSE;
}

/*------------------------------------------------------------------------*/

BOOL    AddCfg(         char	*Id,
                        char    *List )
{
static  CfgRec  Cfg;

        if ( FindCfg(Id,&Cfg) ) ErrorExit("Config %s already defined",Id);

        strcpy(Cfg.Id,Id);
        strcpy(Cfg.List,List);

        ListLast(CfgList);

        if      ( !ListAdd(CfgList,sizeof(CfgRec),&Cfg) )
                ErrorExit("Can't add config %s to list",Id);

        if ( Verbose ) printf("Config %s is defined\n",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

void    ShowConfigs(    BOOL    Spaced )
{
static  CfgRec  Cfg;
        int     Count = ZERO;
        int     Size;

        printf("Configurations:\n");
        if ( Spaced ) printf("\n");

        if      ( ListFirst(CfgList) )
        do
        {
                Size = sizeof(CfgRec);

                if      ( !ListGet(CfgList,&Size,&Cfg) )
                        ErrorExit("Can't get config for listing",NULL);

                if      ( Size != sizeof(CfgRec) )
                        ErrorExit("Wrong size when listing configs",NULL);

                printf("%s -> %s\n",Cfg.Id,Cfg.List);
                Count++;
        }
        while   ( ListNext(CfgList) );

        if ( Count == ZERO ) printf("%s\n",EMPTY_PARAMS);
}

/* ====================================================================== */

BOOL    FindMac(        char	*Id,
                        MacRec  *Mac )
{
        int Size = sizeof(MacRec);

        if      ( ListFirst(MacList) )
        do
        {
                if      ( !ListGet(MacList,&Size,Mac) )
                        ErrorExit("Can't retrieve macro",Id);

                if      ( Size != sizeof(MacRec) )
                        ErrorExit("Incorrect size of macro",Id);

                if ( IsSame(Id,Mac->Id) ) return TRUE;
        }
        while   ( ListNext(MacList) );

        return  FALSE;
}

/*------------------------------------------------------------------------*/

BOOL    AddMac(         char	*Id,
                        char    *Text )
{
static  MacRec  Mac;

        if ( FindMac(Id,&Mac) ) ErrorExit("Macro %s already defined",Id);

        strcpy(Mac.Id,Id);
        strcpy(Mac.Text,Text == NULL ? NILSTR : Text);

        ListLast(MacList);

        if      ( !ListAdd(MacList,sizeof(MacRec),&Mac) )
                ErrorExit("Can't add macro %s to list",Id);

        if ( Verbose ) printf("Macro %s is defined\n",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    AlterMac(       char	*Id,
                        char    *Text )
{
static  MacRec  Mac;

        if ( !FindMac(Id,&Mac) ) ErrorExit("Macro %s not defined",Id);

        strcpy(Mac.Text,Text == NULL ? NILSTR : Text);

        if      ( !ListSet(MacList,sizeof(MacRec),&Mac) )
                ErrorExit("Cannot update macro %s",Id);

        if ( Verbose ) printf("Macro %s is redefined\n",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

void    ShowMacros(     BOOL    Spaced )
{
static  MacRec  Mac;
        int     Count = ZERO;
        int     Size;

        printf("Macros:\n");
        if ( Spaced ) printf("\n");

        if      ( ListFirst(MacList) )
        do
        {
                Size = sizeof(MacRec);

                if      ( !ListGet(MacList,&Size,&Mac) )
                        ErrorExit("Can't get macro for listing",NULL);

                if      ( Size != sizeof(MacRec) )
                        ErrorExit("Wrong size when listing macros",NULL);

                printf("%s -> %s\n",Mac.Id,Mac.Text);
                Count++;
        }
        while   ( ListNext(MacList) );

        if ( Count == ZERO ) printf("%s\n",EMPTY_PARAMS);
}

/* ====================================================================== */

BOOL    FindVar(        char	*Id,
                        VarRec  *Var )
{
        int Size = sizeof(VarRec);

        if      ( ListFirst(VarList) )
        do
        {
                if      ( !ListGet(VarList,&Size,Var) )
                        ErrorExit("Can't retrieve var",Id);

                if      ( Size != sizeof(VarRec) )
                        ErrorExit("Incorrect size of var",Id);

                if ( IsSame(Id,Var->Id) ) return TRUE;
        }
        while   ( ListNext(VarList) );

        return  FALSE;
}

/*------------------------------------------------------------------------*/

BOOL    AddVar(         char	*Id,
                        char    *Expr )
{
static  VarRec  Var;

        if ( FindVar(Id,&Var) ) ErrorExit("Switch %s already defined",Id);

        Var.Value = FALSE;
        strcpy(Var.Id,Id);
        strcpy(Var.Expr,Expr);

        ListLast(VarList);

        if      ( !ListAdd(VarList,sizeof(VarRec),&Var) )
                ErrorExit("Can't add switch %s to list",Id);

        if ( Verbose ) printf("Switch %s is defined\n",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    SetVar(         char	*Id,
                        BOOL    Value )
{
static  VarRec  Var;

        if ( !FindVar(Id,&Var) ) ErrorExit("Switch %s not defined",Id);

        if ( IsPresent(Var.Expr) ) ErrorExit("%s is a derived switch",Id);

        Var.Value = Value;

        if      ( !ListSet(VarList,sizeof(VarRec),&Var) )
                ErrorExit("Cannot update switch %s",Id);

        return  TRUE;
}

/* ====================================================================== */

char    *HandleNots(    char    *Id,
                        BOOL    *Value )
{
        while   ( *Id == *(NOT_OP) )
                *Value = !(*Value),
                Id++;

        return  Id;
}

/*------------------------------------------------------------------------*/

char    *RawId(         char	*Id )
{
        Tag     IdNew;
        BOOL    Dummy = FALSE;

        strcpy(IdNew,Id);

        return  HandleNots(Id,&Dummy);
}

/*------------------------------------------------------------------------*/

char    *BoolStr(       BOOL    Value )
{
        return  Value ? "TRUE" : "FALSE";
}

/*------------------------------------------------------------------------*/

char    *YesNoStr(      BOOL    Value )
{
        return  Value ? "YES" : "no ";
}

/* ====================================================================== */

char    *GetDatim(      void )
{
static  char    Datim[128];

        time_t  Now;

        time(&Now);

        strcpy(Datim,ctime(&Now));

        StripCRLF(Datim);

        return  Datim;
}

/*------------------------------------------------------------------------*/

char    *GetDate(       void )
{
static  char    Date[128];

        time_t    Now;
        struct tm *NowL;

        time(&Now);
        NowL = localtime(&Now);

        sprintf(Date,"%04d%02d%02d",
                     NowL->tm_year+1900,NowL->tm_mon+ONE,NowL->tm_mday);
        return  Date;
}

/*------------------------------------------------------------------------*/

char    *GetTime(       void )
{
static  char    Time[128];

        time_t    Now;
        struct tm *NowL;

        time(&Now);
        NowL = localtime(&Now);

        sprintf(Time,"%02d%02d%02d",NowL->tm_hour,NowL->tm_min,NowL->tm_sec);

        return  Time;
}

/* ====================================================================== */

typedef struct
        {
                int     SP;
                BOOL    Cell[MAX_EXPR_STACK];
        }       Stack;


Stack   IFStack;

/*------------------------------------------------------------------------*/

void    InitStack(      Stack   *S )
{
        S->SP = -ONE;
}

BOOL    PushStack(      Stack   *S,
                        BOOL    Value )
{
        if ( S->SP >= ( MAX_EXPR_STACK - ONE ) ) return FALSE;

        S->Cell[++S->SP] = Value;

        return  TRUE;
}

BOOL    PopStack(       Stack   *S,
                        BOOL    *Value )
{
        if ( S->SP <= -ONE ) return FALSE;

        *Value = S->Cell[S->SP--];

        return  TRUE;
}

BOOL    PeekStack(      Stack   *S,
                        BOOL    *Value )
{
        if ( S->SP <= -ONE ) return FALSE;

        *Value = S->Cell[S->SP];

        return TRUE;
}

/* ====================================================================== */

static  long    LineNumber = ZERO;
static  SrcRec  CurrFile   = {ZERO,NULL,NILSTR};

/*------------------------------------------------------------------------*/

BOOL    OpenSrc(        char    *FileName )
{
static  FName   UsedName;

        CurrFile.LNum = LineNumber;

        if      ( !ListAdd(SrcList,sizeof(SrcRec),&CurrFile) )
                ErrorExit("Can't add source to list for %s",FileName);

        strcpy(UsedName,FileName);

        CurrFile.Hand = fopen(UsedName,"rb");

        if      ( CurrFile.Hand == NULL )
        {
                strcat(UsedName,SOURCE_EXT);
                CurrFile.Hand = fopen(UsedName,"rb");
        }

        if ( CurrFile.Hand == NULL ) return FALSE;

        strcpy(CurrFile.Name,UsedName);
        CurrFile.LNum = LineNumber = ZERO;

        if ( Debugging ) printf("Opened source %s\n",CurSrc());

        return TRUE;
}

/*------------------------------------------------------------------------*/

char    *GetSrc(        char    *DestBuff,
                        int     DestLen )
{
        int     Size;
        char    *Res;

        if      ( CurrFile.Hand == NULL )
                ErrorExit("Unexpected include from file %s",CurrFile.Name);

        while   ( (Res=fgets(DestBuff,DestLen,CurrFile.Hand)) == NULL )
        {
                fclose(CurrFile.Hand);

                if      ( Debugging )
                        printf("Closed source %s\n",CurSrc());

                Size = sizeof(SrcRec);

                if      ( !ListGet(SrcList,&Size,&CurrFile) )
                        ErrorExit("Can't get source for closing",NULL);

                if      ( Size != sizeof(SrcRec) )
                        ErrorExit("Incorrect size of source",CurrFile.Name);

                if     ( !ListDel(SrcList) )
                       ErrorExit("Can't delete old source entry",CurrFile.Name);

                if ( !ListLast(SrcList) ) return NULL;

                LineNumber = CurrFile.LNum;
        }

        ++LineNumber;

        return Res;
}

/*------------------------------------------------------------------------*/

char    *CurSrc(        void )
{
static  char    SrcInfo[MAX_LINE_LEN+ONE];

        if      ( CurrFile.Hand == NULL )
                sprintf(SrcInfo,"?(%lu)",LineNumber);
        else
                sprintf(SrcInfo,"%s(%lu)",CurrFile.Name,LineNumber);

        return SrcInfo;
}

/*------------------------------------------------------------------------*/

char    *NameSrc(       void )
{
        return CurrFile.Name;
}

/* ====================================================================== */

BOOL    DoSetItem(      char	*Param,
                        BOOL    Invert,
                        BOOL    LookInCfgs );

BOOL    DoSetCfg(       char	*Id,
                        BOOL    Invert )
{
        CfgRec  Cfg;
        char    ListTxt[MAX_LINE_LEN+ONE];
        char    *List = ListTxt;
        Tag     NextTxt;
        char    *Next;
        BOOL    NextInv;

        if ( !FindCfg(Id,&Cfg) ) ErrorExit("Config %s not defined",Id);

        if     ( Verbose )
               printf("Selecting configuration %s%s\n",Invert?NOT_OP:NILSTR,Id);

        strcpy(List,Cfg.List);

        while   ( List != NULL )
        {
                List = ExtractNextId(NextTxt,List);

                NextInv = Invert;
                Next = HandleNots(NextTxt,&NextInv);

                if      ( !DoSetItem(Next,NextInv,!IsSame(Id,RawId(Next))) )
                        return  FALSE;
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

/* Does the required action for either a variable *or* a config. */

BOOL    DoSetItem(      char	*Param,
                        BOOL    Invert,
                        BOOL    LookInCfgs )
{
        Tag     IdTxt;
        char    *Id = IdTxt;
        union
        {
                VarRec  Var;
                CfgRec  Cfg;
        }       x;

        strcpy(Id,Param);
        AllToUpper(Id);

        Id = HandleNots(Id,&Invert);

        if      ( LookInCfgs && FindCfg(Id,&x.Cfg) )
                return  DoSetCfg(Id,Invert);

        if      ( FindVar(Id,&x.Var) )
        {
                if      ( !SetVar(Id,!Invert) )
                        ErrorExit("Cannot set value of %s",Id);

                if      ( Verbose )
                        printf("Switch %s is set to %s\n",
                                                      Id,BoolStr(Evaluate(Id)));
                return  TRUE;
        }

        if      ( LookInCfgs )
                ErrorExit("Neither config nor switch %s is defined",Id);
        else
                ErrorExit("Switch %s not found",Id);

        return  FALSE;
}

/* ====================================================================== */

BOOL    IsOption(       char    *Param )
{
        return  (  ( strpos(OPTION_STR,*Param) >= ZERO )
                || (  ( strlen(Param) == ONE )
                   && ( *Param == DUMP_OPTION ) ) );
}

/*------------------------------------------------------------------------*/

void    ShowUsage(      void )
{
        printf("\n");
        printf("Usage: CFG2 [<opt>|[!]<switch>|[!]<config>]..."
                           "[<opt>|[!]<switch>|[!]<config>]\n");
        printf("\n");
        printf("Example: CFG2 -fhex.ini -pc:\\ java !scsi2940 !winrun -t\n");
        printf("\n");
        printf("This program is a configuration file generation utility.\n");
        printf("Use 'CFG2 -H' for options and grammar.\n");
}

/*------------------------------------------------------------------------*/

void    ShowHelp(       void )
{
char    **NextWord = SpecialWords;

 printf("\n");
 printf("Parameters are '%c%c<filename>'"
        " to specify the source file name,\n",
                                        *(OPTION_STR),CFG_NAME_OPTION);

 printf("'%c%c<pathname>' to specify a path that"
        " will be placed in front of *all* file\n",
                                        *(OPTION_STR),PATH_OPTION);

 printf("names, '%c%c' to toggle verbose"
        " mode and '%c%c' to get this help text.\n",
                                        *(OPTION_STR),VERBOSE_OPTION,
                                        *(OPTION_STR),HELP_OPTION);

 printf("Version-dependant debugging actions"
        " can be invoked by using '%c%c'.\n",
                                        *(OPTION_STR),DEBUG_OPTION);
 printf("The program can be made to dump source"
        " lines as they are read in.  To do\n");

 printf("this, use '%c%c'.\n",          *(OPTION_STR),TRACE_OPTION);

 printf("\n");
 printf("The current 'special' word set is:\n");
 printf("\n");

 for     ( NextWord=SpecialWords ; *NextWord!=NULL ; NextWord+=TWO )
         printf(*(NextWord+ONE),*NextWord);

 printf("\n");

 printf("Other than when being *defined*, file"
        " name tags can be 'wild-carded'.  For\n");

 printf("example, something like '%s TEMP*' can"
        " be used to delete all files that\n",
                                        DELETE_WORD);

 printf("start with 'TEMP'.  (The '%c' character"
        " matches any single character while\n",
                                        WILD_ONE_CHAR);

 printf("the '%c' character matches zero or more characters.)\n",
                                        WILD_MANY_CHAR);
 printf("\n");

 printf("Operators are '%s', '%s', '%s' and '%s' which"
        " correspond to 'and', 'or', 'xor' and 'not'\n",
                                        AND_OP,OR_OP,XOR_OP,NOT_OP);

 printf("respectively.  The 'same as last line"
        " character is '%s'.  The comment'\n",
                                        SAME_AS_BEFORE);

 printf("character is '%c'. The tag and environment"
        " variable expansion char is '%c',\n",
                                        COMMENT_CHAR,*(EXPAND_CHAR));

 printf("while the 'generate an empty line' character"
        " is '%c'.  The new-line that is\n",
                                        EMPTY_LINE_CHAR);

 printf("normally appended to each output line in"
        " a file can be inhibited by using\n");

 printf("'%c' as the last character on the line concerned.  (This action can\n",
                                        NO_CRLF_CHAR);
 printf("be inhibited by using *two* '%c' characters together.)\n",
                                        NO_CRLF_CHAR);
 printf("\n");

 printf("The special configuration switch '%s' will"
        " be executed on *every* run\n",ALWAYS_CONFIG);

 printf("whereas '%s' will only be invoked if no switches"
        " are specified on the\n",      DEFAULT_CONFIG);

 printf("command-line.  The special 'is only one switch set?'"
        " operator is '%s'.\n",         JUSTONE_OP);

 printf("\n");

 printf("The program has an 'text expansion' facility.  For example, using\n");

 printf("'%%%s%%' will generate the program name and version number,\n",
                                        EXPAND_PROGNAME);

 printf("'%%%s%%' will produce the list of parameters used and '%%%s%%'\n",
                                        EXPAND_PARAMS,EXPAND_SWITCHES);

 printf("will expand to the current switch state.  Using"
        " '%%%s%%' will give you\n",    EXPAND_SOURCE);

 printf("the name of the current source file.  The date and"
        " time can be output by\n");

 printf("using '%%%s%%', which produces the current date and time"
        " in a plain\n",                EXPAND_DATIM);

 printf("text format.  If you want *numeric* dates and times, you can use\n");

 printf("'%%%s%%' or '%%%s%%', respectively. A file tag name, switch"
        " tag name\n",                  EXPAND_DATE,EXPAND_TIME);

 printf("or operating system evironment can"
        " all be expanded in the same way - they\n");

 printf("expand to the 'real' file name, the switch"
        " 'value' and the variable value,\n");

 printf("respectively.\n");

 printf("\n");
 printf("A tag can be a maximum of %d characters long and each"
        " input line can be %d\n",      MAX_ID_LEN,MAX_LINE_LEN);

 printf("characters at most. The expression stack has enough room"
        " for %d entries.\n",           MAX_EXPR_STACK);

 printf("The default margin width is %d with tabs being expanded to"
        " every %d columns.\n",         DEFAULT_MARGIN,DEFAULT_TAB);

 printf("Verbose defaults '%s'. The passing of empty lines defaults"
        " '%s'.\n",                     DEFAULT_VERBOSE?"on":"off",
                                        DEFAULT_PASSEMPTY?"on":"off");
 printf("\n");

 printf("This program is a ChAoS utility - please visit www.glod.net.\n");

 printf("\n");
}

/*------------------------------------------------------------------------*/

int     GlobArgc;
char    **GlobArgv;

void    DoOptions(      void )
{
        int     i;
        char    *Opt;

        strcpy(CfgFileName,NILSTR);
        strcpy(PathName,NILSTR);

        for     ( i=ONE ; i<GlobArgc ; i++ )
        {
                Opt = GlobArgv[i];

                if      ( IsOption(Opt) )
                        switch  ( toupper(Opt[ONE]) )
                        {
                        case CFG_NAME_OPTION:
                                        strcpy(CfgFileName,Opt+TWO);
                                        break;

                        case PATH_OPTION:
                                        strcpy(PathName,Opt+TWO);
                                        break;

                        case DEBUG_OPTION:
                                        Debugging = TRUE;
                                        Tracing   = TRUE;
                                        Verbose   = TRUE;
                                        break;

                        case TRACE_OPTION:
                                        Tracing   = TRUE;
                                        break;

                        case VERBOSE_OPTION:
                                        Verbose = !Verbose;
                                        break;

                        case HELP_OPTION:
                                        ShowHelp();
                                        exit(EXIT_FAILURE);
                        default:
                                        ErrorExit("Bad param '%s'",Opt);
                        }
        }

        if ( !IsPresent(CfgFileName) ) GetCfgFileName(CfgFileName,GlobArgv);
}

/*------------------------------------------------------------------------*/

char    GlobParams[MAX_LINE_LEN+ONE];
char    GlobSwitches[MAX_LINE_LEN+ONE];

/*------------------------------------------------------------------------*/

void    MakeSwitchStr(  void )
{
static  VarRec  Var;
        Tag     Id;
        int     Size;

        strcpy(GlobSwitches,NILSTR);

        if      ( ListFirst(VarList) )
        do
        {
                Size = sizeof(VarRec);

                if      ( !ListGet(VarList,&Size,&Var) )
                        ErrorExit("Can't create switch string",NULL);

                if      ( Size != sizeof(VarRec) )
                        ErrorExit("Wrong size when making switch string",NULL);

                strcpy(Id,Var.Id);

                if      ( Evaluate(Id) )
                {
                        if      ( strlen(GlobSwitches) > ZERO )
                                strcat(GlobSwitches,SPACESTR);

                        strcat(GlobSwitches,Id);
                }

                if   ( !FindVar(Id,&Var) )
                     ErrorExit("make switch string cannot re-postion on %s",Id);
        }
        while   ( ListNext(VarList) );
}

/*------------------------------------------------------------------------*/

BOOL    DoParams(       void );

void    ShowSwitches(   BOOL    All )
{
static  VarRec  Var;
        Tag     Id;
        int     Count = ZERO;
        int     Size;

        if ( !DoParams() ) ErrorExit("Can't do parameters (1)",NULL);

        printf("%s switches:", All ? "Defined" : "Selected");
        if ( All ) printf("\n\n");

        if      ( ListFirst(VarList) )
        do
        {
                Size = sizeof(VarRec);

                if      ( !ListGet(VarList,&Size,&Var) )
                        ErrorExit("Can't get switch for listing",NULL);

                if      ( Size != sizeof(VarRec) )
                        ErrorExit("Wrong size when listing switches",NULL);

                strcpy(Id,Var.Id);

                if      ( All || Evaluate(Id) )
                {
                        if ( !All ) printf(" ");
                        printf("%s",Id);
                        if ( All ) printf(" ");
                        Count++;
                }

                if      ( !FindVar(Id,&Var) )
                        ErrorExit("Show switches cannot re-postion on %s",Id);
        }
        while   ( ListNext(VarList) );

        if ( Count == ZERO ) printf("%s",EMPTY_PARAMS);

        printf("\n");
}

/*------------------------------------------------------------------------*/

BOOL    DoParams(       void )
{
static  ParamsDone = FALSE;

static  CfgRec  Cfg;
        int     i;
        BOOL    AnySets = FALSE;

        if ( ParamsDone ) return TRUE;
        ParamsDone = TRUE;

        if ( Debugging ) printf("Processing command-line parameters\n");

        if      ( FindCfg(ALWAYS_CONFIG,&Cfg) )
                if      ( !DoSetItem(ALWAYS_CONFIG,FALSE,TRUE) )
                        return  FALSE;

        for     ( i=ONE ; i<GlobArgc ; i++ )
                AnySets |= !IsOption(GlobArgv[i]);

        if      ( !AnySets )
        {
                if      ( FindCfg(DEFAULT_CONFIG,&Cfg) )
                        if      ( !DoSetItem(DEFAULT_CONFIG,FALSE,TRUE) )
                                return  FALSE;
        }
        else
                for     ( i=ONE ; i<GlobArgc ; i++ )
                        if      ( !IsOption(GlobArgv[i]) )
                        {
                                if      ( strlen(GlobParams) > ZERO )
                                        strcat(GlobParams,SPACESTR);

                                strcat(GlobParams,GlobArgv[i]);

                                if      ( !DoSetItem(GlobArgv[i],FALSE,TRUE) )
                                        return  FALSE;
                        }

        if ( strlen(GlobParams) == ZERO ) strcpy(GlobParams,EMPTY_PARAMS);

        MakeSwitchStr();

        if ( Verbose ) ShowSwitches(FALSE);

        return  TRUE;
}

/* ====================================================================== */

BOOL    Evaluate(       char    *ExprTxt )
{
        VarRec  Var;
        char    *Expr = ExprTxt;
        char    NextExpr[MAX_LINE_LEN+ONE];
        char    *Next;
        BOOL    Invert;
        BOOL    Result;
        BOOL    TempL, TempR;
        Stack   S;

        InitStack(&S);

        while   ( Expr != NULL )
        {
                Expr = ExtractNextId(NextExpr,Expr);

                if      ( IsSame(NextExpr,AND_OP) )
                {
                        if    ( !PopStack(&S,&TempL) )
                              ErrorExit("Eval stack underflow 'at' %s operator",
                                                                        AND_OP);
                        if    ( !PopStack(&S,&TempR) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                        AND_OP);
                        if    ( !PushStack(&S,TempL&&TempR) )
                              ErrorExit("Eval stack overflow at '%s' operator",
                                                                        AND_OP);
                }
                else
                if      ( IsSame(NextExpr,OR_OP) )
                {
                        if    ( !PopStack(&S,&TempL) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                         OR_OP);
                        if    ( !PopStack(&S,&TempR) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                         OR_OP);

                        if    ( !PushStack(&S,TempL||TempR) )
                              ErrorExit("Eval stack overflow at '%s' operator",
                                                                         OR_OP);
                }
                else
                if      ( IsSame(NextExpr,XOR_OP) )
                {
                        if    ( !PopStack(&S,&TempL) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                        XOR_OP);
                        if    ( !PopStack(&S,&TempR) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                        XOR_OP);

                        if    ( !PushStack(&S,TempL^TempR) )
                              ErrorExit("Eval stack overflow at '%s' operator",
                                                                        XOR_OP);
                }
                else
                if      ( IsSame(NextExpr,NOT_OP) )
                {
                        if    ( !PopStack(&S,&TempL) )
                              ErrorExit("Eval stack underflow at '%s' operator",
                                                                        NOT_OP);

                        if    ( !PushStack(&S,!TempL) )
                              ErrorExit("Eval stack overflow at '%s' operator",
                                                                        NOT_OP);
                }
                else
                if      ( IsSame(NextExpr,JUSTONE_OP) )
                {
                        int     Tested = ZERO;  /* Items tested so far. */
                        int     Active = ZERO;  /* Items that were TRUE. */

                        while   ( PopStack(&S,&TempL) )
                        {
                                ++Tested;
                                if ( TempL ) ++Active;
                        }

                        if     ( Tested <= ZERO )
                               ErrorExit("No operands at '%s' operator",
                                                                    JUSTONE_OP);
                        if     ( !PushStack(&S,(Active==ONE)) )
                               ErrorExit("Eval stack overflow at '%s' operator",
                                                                    JUSTONE_OP);
                }
                else
                {
                        Invert = FALSE;
                        Next = HandleNots(NextExpr,&Invert);

                        if      ( !FindVar(Next,&Var) )
                                ErrorExit("Cannot find switch %s",Next);

                        if      ( !IsPresent(Var.Expr) )
                                Result = Var.Value;
                        else
                        {
                                strcpy(NextExpr,Var.Expr);
                                Result = Evaluate(NextExpr);
                        }

                        if ( Invert ) Result = !Result;

                        if      ( !PushStack(&S,Result) )
                                ErrorExit("Expr calc stack overflow",NULL);
                }
        }

        if      ( !PopStack(&S,&TempL) )
                ErrorExit("Eval result stack underflow",NULL);

        if      ( PeekStack(&S,&TempR) )
                ErrorExit("Operator missing in expression",NULL);

        return  TempL;
}

/* ====================================================================== */

BOOL    FindFil(        char	*Id,
                        FilRec  *Fil )
{
        int Size = sizeof(FilRec);

        if ( Debugging ) printf("Looking for file %s\n",Id);

        if      ( ListFirst(FilList) )
        do
        {
                if      ( !ListGet(FilList,&Size,Fil) )
                        ErrorExit("Can't retrieve file",Id);

                if      ( Size != sizeof(FilRec) )
                        ErrorExit("Incorrect size of file",Id);

                if ( IsSame(Id,Fil->Id) ) return TRUE;
        }
        while   ( ListNext(FilList) );

        if ( Debugging ) printf("File %s not found\n",Id);

        return  FALSE;
}

/*------------------------------------------------------------------------*/

BOOL    AddFil(         char	*Id,
                        char    *Name,
                        int     FileType )
{
static  FilRec  Fil;

        if ( Debugging ) printf("Adding file %s (%s)\n",Id,Name);

        if ( FindFil(Id,&Fil) ) ErrorExit("File %s already defined",Id);

        Fil.Open  = FALSE;
        Fil.Trunc = TRUE;
        Fil.Used  = FALSE;
        Fil.CRLF  = TRUE;
        Fil.Type  = FileType;
        Fil.Hand  = NULL;

        strcpy(Fil.Id,Id);

        strcpy(Fil.Name,PathName);
        strcat(Fil.Name,Name);

        ListLast(FilList);

        if      ( !ListAdd(FilList,sizeof(FilRec),&Fil) )
                ErrorExit("Can't add file %s to list",Id);

        if ( Verbose ) printf("File %s (%s) is defined\n",Id,Name);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    OpenFile(       char	*Id )
{
static  FilRec  Fil;

        if ( Debugging ) printf("Opening file %s\n",Id);

        if      ( !FindFil(Id,&Fil) )
        {
                if ( Debugging ) printf("File %s not found\n",Id);
                return FALSE;
        }

        if      ( Fil.Type != OUTPUT_FILE )
                ErrorExit("File %s is not an output file",Id);

        if      ( !Fil.Open )
        {
                if      ( Debugging )
                        printf("Truncation flag is %s\n",BoolStr(Fil.Trunc));

                Fil.Hand = fopen(Fil.Name,Fil.Trunc?"w":"a");
                Fil.Open = ( Fil.Hand != NULL );

                if      ( Fil.Open )
                        Fil.Trunc = FALSE;
                else
                        if ( Debugging ) printf("File %s not opened\n",Id);
        }
        else
                if ( Debugging ) printf("File %s already opened\n",Id);

        if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                ErrorExit("Cannot update file %s",Id);

        return  Fil.Open;
}

/*------------------------------------------------------------------------*/

BOOL    UseFile(        char	*Id )
{
static  FilRec  Fil;

        if ( Debugging ) printf("Using file %s\n",Id);

        if      ( !FindFil(Id,&Fil) )
        {
                if ( Debugging ) printf("File %s not found\n",Id);
                return FALSE;
        }

        if      ( Fil.Type != OUTPUT_FILE )
                ErrorExit("File %s is not an output file",Id);

        if      ( Debugging )
                if      ( Fil.Used )
                        printf("File %s already in use\n",Id);
                else
                        printf("File %s now in use\n",Id);

        Fil.Used = TRUE;

        if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                ErrorExit("Cannot update file %s",Id);

        return  Fil.Used;
}


/*------------------------------------------------------------------------*/

void    SendFile(       FilRec  *Fil,
                        char    *Line,
                        BOOL    Raw )
{
static  char    Txt[MAX_LINE_LEN+ONE];
        int     Last;

        if ( !Fil->Used ) return;

        if      ( Raw )
        {
                fprintf(Fil->Hand,"%s\n",Line);
                return;
        }

        strcpy(Txt,Line);

        if ( !Fil->CRLF ) StripLeadChar(Txt,SPACE);

        Last = strlen(Txt) - ONE;

        Fil->CRLF = TRUE;

        if      ( IsPresent(Txt)  )
        {
                if      ( ( Last == ZERO ) && ( Txt[Last] == EMPTY_LINE_CHAR ) )
                        /* Generate a blank line. */;
                else
                {
                        if      ( Txt[Last] == NO_CRLF_CHAR )
                        {
                                Txt[Last] = EOS;

                                if      ( ( Last <= ZERO )
                                ||        ( Txt[Last-ONE] != NO_CRLF_CHAR ) )
                                        Fil->CRLF = FALSE;
                        }

                        fprintf(Fil->Hand,"%s",Txt);
                }

                if ( Fil->CRLF ) fprintf(Fil->Hand,"\n");
        }
        else
        if      ( PassEmpty )
                fprintf(Fil->Hand,"\n");
}

/*------------------------------------------------------------------------*/

void    UnUseFile(      FilRec  *Fil )
{
        if      ( Debugging )
        {
                printf("Unusing file %s\n",Fil->Id);

                if      ( Fil->Used )
                        printf("File %s now unused\n",Fil->Id);
                else
                        printf("File %s already unused\n",Fil->Id);
        }

        Fil->Used = FALSE;
}

/*------------------------------------------------------------------------*/

BOOL    CloseFile(      char	*Id )
{
static  FilRec  Fil;

        if ( Debugging ) printf("Closing file %s\n",Id);

        if ( !FindFil(Id,&Fil) ) return FALSE;

        if      ( Fil.Open )
        {
                fclose(Fil.Hand);

                Fil.Open = FALSE;
                if ( Debugging ) printf("File %s closed\n",Id);
        }
        else
                if ( Debugging ) printf("File %s already closed\n",Id);

        if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                ErrorExit("Cannot update file %s",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DeleteFile(     char	*Id )
{
static  FilRec  Fil;
static  FName   Name;

        if ( Debugging ) printf("Deleting file %s\n",Id);

        if ( !FindFil(Id,&Fil) ) return FALSE;

        if      ( Fil.Type != OUTPUT_FILE )
                ErrorExit("File %s is not an output file",Id);

        strcpy(Name,Fil.Name);

        if ( Fil.Open && !CloseFile(Id) ) return FALSE;

        Fil.Trunc = TRUE;

        if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                ErrorExit("Cannot update file %s",Id);

        if ( IsPresent(Name) ) remove(Name);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

void    SendFiles(      char    *Line,
                        BOOL    Raw )
{
static  FilRec  Fil;
        int     Size;

        if      ( ListFirst(FilList) )
        do
        {
                Size = sizeof(FilRec);

                if      ( !ListGet(FilList,&Size,&Fil) )
                        ErrorExit("Can't get file for sending",NULL);

                if      ( Size != sizeof(FilRec) )
                        ErrorExit("Wrong size when sending files",NULL);

                SendFile(&Fil,Line,Raw);

                if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                        ErrorExit("Cannot update file %s",Fil.Id);
        }
        while   ( ListNext(FilList) );
}

/*------------------------------------------------------------------------*/

void    CloseAllFiles(  void )
{
static  FilRec  Fil;
        int     Size;

        if      ( ListFirst(FilList) )
        do
        {
                Size = sizeof(FilRec);

                if      ( !ListGet(FilList,&Size,&Fil) )
                        ErrorExit("Can't get file for closing",NULL);

                if      ( Size != sizeof(FilRec) )
                        ErrorExit("Wrong size when closing files",NULL);

                if ( Fil.Open ) CloseFile(Fil.Id);
        }
        while   ( ListNext(FilList) );
}

/*------------------------------------------------------------------------*/

void    ShowFiles(      void )
{
static  FilRec  Fil;
        int     Size;

        printf("\nOpen Used Type Trun CRLF Tag->Name\n\n");

        if      ( ListFirst(FilList) )
        do
        {
                Size = sizeof(FilRec);

                if      ( !ListGet(FilList,&Size,&Fil) )
                        ErrorExit("Can't get file for closing",NULL);

                if      ( Size != sizeof(FilRec) )
                        ErrorExit("Wrong size when closing files",NULL);

                printf("%s  ",YesNoStr(Fil.Open));
                printf("%s  ",YesNoStr(Fil.Used));

                switch  ( Fil.Type )
                {
                case OUTPUT_FILE: printf("OUT  "); break;
                case INPUT_FILE:  printf("IN   "); break;
                case SOURCE_FILE: printf("SRC  "); break;
                default:          printf("?    "); break;
                }

                printf("%s  ",YesNoStr(Fil.Trunc));
                printf("%s  ",YesNoStr(Fil.CRLF));
                printf("%s '%s'",Fil.Id,Fil.Name);

                printf("\n");
        }
        while   ( ListNext(FilList) );

        printf("\n");
}

/*------------------------------------------------------------------------*/

/* Does *not* update the file list since the source file is opened, read
 * and closed all within this function.
 */

BOOL    ReadFile(       char	*Id )
{
static  FilRec  Fil;
static  char    Line[MAX_LINE_LEN+ONE];

        if ( Debugging ) printf("Reading file %s\n",Id);

        if      ( !FindFil(Id,&Fil) )
        {
                if ( Debugging ) printf("Data file %s not found\n",Id);
                return FALSE;
        }

        if      ( Fil.Type != INPUT_FILE )
                ErrorExit("File %s is not an input file",Id);

        Fil.Hand = fopen(Fil.Name,"r");

        if      ( Fil.Hand == NULL )
        {
                if ( Debugging ) printf("File %s not opened\n",Id);
                return FALSE;
        }

        while   ( fgets(Line,MAX_LINE_LEN,Fil.Hand) != NULL )
        {
                StripCRLF(Line);
                SendFiles(Line,TRUE);
        }

        fclose(Fil.Hand);

        return TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    IncludeFile(    char	*Id )
{
static  FilRec  Fil;

        if ( Debugging ) printf("Including file %s\n",Id);

        if      ( !FindFil(Id,&Fil) )
        {
                if ( Debugging ) printf("Source file %s not found\n",Id);
                return FALSE;
        }

        if      ( Fil.Type != SOURCE_FILE )
                ErrorExit("File %s is not a source file",Id);

        return  OpenSrc(Fil.Name);
}

/* ====================================================================== */

void    ExpandString(   char    *Start,
                        char    *End )
{
static  char    Pattern[MAX_LINE_LEN+ONE];
static  FilRec  Fil;
static  VarRec  Var;
static  MacRec  Mac;
        char    *EnvStr;

        strcpy(Pattern,Start+ONE);
        Pattern[End-Start-ONE] = EOS;

        strdel(Start,ZERO,End-Start+ONE);

        AllToUpper(Pattern);

        if      ( (EnvStr=getenv(Pattern)) != NULL )
                strins(Start,EnvStr,ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_PROGNAME) )
                strins(Start,PROGNAME,ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_PARAMS) )
                strins(Start,GlobParams,ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_SWITCHES) )
                strins(Start,GlobSwitches,ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_SOURCE) )
                strins(Start,NameSrc(),ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_DATIM) )
                strins(Start,GetDatim(),ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_DATE) )
                strins(Start,GetDate(),ZERO);
        else
        if      ( IsSame(Pattern,EXPAND_TIME) )
                strins(Start,GetTime(),ZERO);
        else
        if      ( FindMac(Pattern,&Mac) )
                strins(Start,Mac.Text,ZERO);
        else
        if      ( FindFil(Pattern,&Fil) )
                strins(Start,Fil.Name,ZERO);
        else
        if      ( FindVar(Pattern,&Var) )
        {
                if ( !DoParams() ) ErrorExit("Can't do parameters (2)",NULL);

                strins(Start,BoolStr(Evaluate(Pattern)),ZERO);
        }
}

/*------------------------------------------------------------------------*/

char    *ExpandEnv(     char    *s )
{
        char    *start = s;
        int     pos;

        while   ( *start )
                if      ( *start != *(EXPAND_CHAR) )
                        start++;
                else
                if      ( *(start+ONE) == *(EXPAND_CHAR) )
                {
                        strdel(start,ZERO,ONE);
                        start++;
                }
                else
                {
                        if      ( (pos=strpos(start+ONE,*(EXPAND_CHAR))) < ZERO )
                                return s;

                        ExpandString(start,start+pos+ONE);
                }

        return  s;
}

/* ====================================================================== */

void    DoNormal(       char    *Line,
                        int     Margin )
{
static  char    Expr[MAX_LINE_LEN+ONE];
        BOOL    WantLine;
static  BOOL    PreviousResult = FALSE;

        strcpy(Expr,Line);
        Expr[Margin] = EOS;

        if      ( Margin > ZERO )
        {
                StripLeadChar(Expr,SPACE);
                StripTrailChar(Expr,SPACE);

                strdel(Line,ZERO,Margin);
        }

        if      ( IsSame(Expr,SAME_AS_BEFORE) )
                WantLine = PreviousResult;
        else
        if      ( !IsPresent(Expr) )
                WantLine = TRUE;
        else
        {
                if ( !DoParams() ) ErrorExit("Can't do parameters (3)",NULL);

                WantLine = Evaluate(Expr);
        }

        if      ( WantLine && ( PassEmpty || IsPresent(Line) ) )
        {
                if ( Verbose ) printf("Sending '%s'\n",Line);
                SendFiles(Line,FALSE);
        }

        PreviousResult = WantLine;
}

/* ====================================================================== */

BOOL    DoIfWord(       char    *Line )
{
        BOOL    Result;
        BOOL    CurRes;

        if ( !DoParams() ) ErrorExit("Can't do parameters (4)",NULL);

        Result = Evaluate(Line);

        if ( !PeekStack(&IFStack,&CurRes) ) CurRes = TRUE;

        if ( !CurRes ) Result = FALSE;

        if      ( !PushStack(&IFStack,Result) )
                ErrorExit("Expr stack overflow in %s",IF_WORD);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoElseWord(     void )
{
        BOOL    Result, CurRes;

        if      ( !PopStack(&IFStack,&Result) )
                ErrorExit("Spurious %s detected",ELSE_WORD);

        Result = !Result;

        if ( !PeekStack(&IFStack,&CurRes) ) CurRes = TRUE;

        if ( !CurRes ) Result = FALSE;

        if      ( !PushStack(&IFStack,Result) )
                ErrorExit("Expr stack overflow in %s",ELSE_WORD);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoEndIfWord(    void )
{
        BOOL    Result;

        if      ( !PopStack(&IFStack,&Result) )
                ErrorExit("Spurious %s detected",ENDIF_WORD);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoFileWord(     char    *WordName,
                        int     FileType,
                        char    *Line )
{
        Tag     Id;

        Line = ExtractNextId(Id,Line);

        if      ( Line == NULL )
                ErrorExit("%s command found no file names",WordName);

        return  AddFil(Id,Line,FileType);
}

/*------------------------------------------------------------------------*/

BOOL    DoCloseWord(    char    *Line )
{
static  FilRec  Fil;
        Tag     Id;
        int     Size;

        if      ( !IsPresent(Line) )
                ErrorExit("No file name found for %s to execute",CLOSE_WORD);

        while   ( Line != NULL )
        {
                BOOL    Done = FALSE;

                Line = ExtractNextId(Id,Line);

                if ( ListFirst(FilList) )
                do
                {
                        Size = sizeof(FilRec);

                        if      ( !ListGet(FilList,&Size,&Fil) )
                                ErrorExit("Can't retrieve file",Id);

                        if      ( Size != sizeof(FilRec) )
                                ErrorExit("Incorrect size of file",Id);

                        if      ( strmatch(Fil.Id,Id) )
                        {
                                if     ( !CloseFile(Fil.Id) )
                                       ErrorExit("Cannot close file %s",Fil.Id);

                                Done = TRUE;
                        }

                }
                while   ( ListNext(FilList) );

                if      ( !Done && !iswildcard(Id) )
                        ErrorExit("Can't find file %s to close",Id);
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoDeleteWord(   char    *Line )
{
static  FilRec  Fil;
        Tag     Id;
        int     Size;

        if      ( !IsPresent(Line) )
                ErrorExit("No file name found for %s to execute",DELETE_WORD);

        while   ( Line != NULL )
        {
                BOOL    Done = FALSE;

                Line = ExtractNextId(Id,Line);

                if ( ListFirst(FilList) )
                do
                {
                        Size = sizeof(FilRec);

                        if      ( !ListGet(FilList,&Size,&Fil) )
                                ErrorExit("Can't retrieve file",Id);

                        if      ( Size != sizeof(FilRec) )
                                ErrorExit("Incorrect size of file",Id);

                        if      ( strmatch(Fil.Id,Id)
                        &&        ( Fil.Type == OUTPUT_FILE ) )
                        {
                                if    ( !DeleteFile(Fil.Id) )
                                      ErrorExit("Cannot delete file %s",Fil.Id);

                                Done = TRUE;
                        }
                }
                while   ( ListNext(FilList) );

                if      ( !Done && !iswildcard(Id) )
                        ErrorExit("Can't find file %s to delete",Id);
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoVarWord(      char    *Line )
{
        Tag     IdTxt;
        char    *Id = IdTxt;
        BOOL    Value = TRUE;
static  char    Expr[MAX_LINE_LEN+ONE];
static  VarRec  Var;

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no id name",VAR_WORD);

        strcpy(Expr,NILSTR);

        Line = ExtractNextId(Id,Line);
        Id   = HandleNots(Id,&Value);

        if ( Line != NULL ) strcpy(Expr,Line);
        AllToUpper(Expr);

        if ( FindVar(Id,&Var) ) ErrorExit("Switch %s already defined",Id);

        if ( !AddVar(Id,Expr) ) ErrorExit("Cannot create switch %s",Id);

        if      ( !IsPresent(Expr) && !SetVar(Id,Value) )
                ErrorExit("Cannot set value of switch %s",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoCfgWord(      char    *Line )
{
        Tag     IdTxt;
        char    *Id = IdTxt;
        BOOL    Value = TRUE;
static  char    List[MAX_LINE_LEN+ONE];
static  CfgRec  Cfg;

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no names",CFG_WORD);

        strcpy(List,NILSTR);

        Line = ExtractNextId(Id,Line);
        Id   = HandleNots(Id,&Value);

        if ( Line == NULL ) ErrorExit("No names found for %s\n",Id);

        strcpy(List,Line);
        AllToUpper(List);

        if ( FindCfg(Id,&Cfg) ) ErrorExit("Config %s already defined",Id);

        if ( !AddCfg(Id,List) ) ErrorExit("Cannot create config %s",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoDefineWord(   char    *Line )
{
        Tag     IdTxt;
        char    *Id = IdTxt;
static  MacRec  Mac;

        Line = ExtractNextId(Id,Line);

        if      ( FindMac(Id,&Mac) )
        {
                Warning("Macro %s already defined",Id);
                if ( !AlterMac(Id,Line) ) ErrorExit("Cannot alter macro %s",Id);
        }
        else
                if ( !AddMac(Id,Line) ) ErrorExit("Cannot create macro %s",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoReDefWord(    char    *Line )
{
        Tag     IdTxt;
        char    *Id = IdTxt;
static  MacRec  Mac;

        Line = ExtractNextId(Id,Line);

        if ( !FindMac(Id,&Mac) ) ErrorExit("Macro %s not defined",Id);

        if ( !AlterMac(Id,Line) ) ErrorExit("Cannot alter macro %s",Id);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoSetWord(      char    *Line )
{
        Tag     Id;

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no names",SET_WORD);

        if ( !DoParams() ) ErrorExit("Can't do parameters (5)",NULL);

        while   ( Line != NULL )
        {
                Line = ExtractNextId(Id,Line);

                if      ( IsPresent(Id) && !DoSetItem(Id,FALSE,TRUE) )
                        return  FALSE;
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoDumpWord(     void )
{
        if ( Debugging ) ReportRTS();

        printf("\n");

        ShowConfigs(FALSE);
        ShowMacros(FALSE);
        ShowSwitches(TRUE);
        ShowFiles();

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoErrorWord(    char    *Text )
{
        ErrorExit(Text,NULL);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoSayWord(      char    *Text )
{
        printf("%s\n",Text);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoSendWord(     char    *Line )
{
static  FilRec  Fil;
        Tag     Id;
        int     Size;

        if ( ListFirst(FilList) )
        do
        {
                Size = sizeof(FilRec);

                if      ( !ListGet(FilList,&Size,&Fil) )
                        ErrorExit("Can't retrieve file",Id);

                if      ( Size != sizeof(FilRec) )
                        ErrorExit("Incorrect size of file",Id);

                UnUseFile(&Fil);

                if      ( !ListSet(FilList,sizeof(FilRec),&Fil) )
                        ErrorExit("Cannot update file %s",Id);
        }
        while   ( ListNext(FilList) );

        if      ( !IsPresent(Line) )
                ErrorExit("No file name found for %s to execute",SEND_WORD);

        while   ( Line != NULL )
        {
                BOOL    Done = FALSE;

                Line = ExtractNextId(Id,Line);

                if ( ListFirst(FilList) )
                do
                {
                        Size = sizeof(FilRec);

                        if      ( !ListGet(FilList,&Size,&Fil) )
                                ErrorExit("Can't retrieve file",Id);

                        if      ( Size != sizeof(FilRec) )
                                ErrorExit("Incorrect size of file",Id);

                        if      ( ( Fil.Type == OUTPUT_FILE )
                        &&        strmatch(Fil.Id,Id) )
                        {
                                if ( !OpenFile(Fil.Id)
                                ||   !UseFile(Fil.Id) )
                                     ErrorExit("Cannot send to file %s",Fil.Id);

                                Done = TRUE;
                        }
                }
                while   ( ListNext(FilList) );

                if      ( !Done && !iswildcard(Id) )
                        ErrorExit("Can't find file %s to send",Id);
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoReadWord(     char    *Line )
{
static  FilRec  Fil;
        Tag     Id;
        int     Size;

        if      ( !IsPresent(Line) )
                ErrorExit("No file name found for %s to execute",READ_WORD);

        while   ( Line != NULL )
        {
                BOOL    Done = FALSE;

                Line = ExtractNextId(Id,Line);

                if ( ListFirst(FilList) )
                do
                {
                        Size = sizeof(FilRec);

                        if      ( !ListGet(FilList,&Size,&Fil) )
                                ErrorExit("Can't retrieve file",Id);

                        if      ( Size != sizeof(FilRec) )
                                ErrorExit("Incorrect size of file",Id);

                        if      ( ( Fil.Type == INPUT_FILE )
                        &&        strmatch(Fil.Id,Id) )
                        {
                                if      ( !ReadFile(Fil.Id) )
                                        ErrorExit("Cannot read file %s",Fil.Id);

                                Done = TRUE;
                        }
                }
                while   ( ListNext(FilList) );

                if      ( !Done && !iswildcard(Id) )
                        ErrorExit("Can't find file %s to read",Id);
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

/* Note that, in the case of source file #INCLUDes, the list files of files is
 * scanned in *reverse* order starting at the *end* of the list.  This is
 * because the sources are merely opened at this juncture - there are *not*
 * actually for their text.  When this function exits, there are effectively
 * "pushed" onto the stack of openeed source files.  Hence, since they are
 * popped off as a normal stack would be, pushing them in *reverse* order makes
 * them get included in the expected order.
 */

BOOL    DoIncWord(      char    *Line )
{
static  FilRec  Fil;
        Tag     Id;
        int     Size;

        if      ( !IsPresent(Line) )
                ErrorExit("No file name found for %s to execute",INC_WORD);

        while   ( Line != NULL )
        {
                BOOL    Done = FALSE;

                Line = ExtractNextId(Id,Line);

                if ( ListLast(FilList) )
                do
                {
                        Size = sizeof(FilRec);

                        if      ( !ListGet(FilList,&Size,&Fil) )
                                ErrorExit("Can't retrieve file",Id);

                        if      ( Size != sizeof(FilRec) )
                                ErrorExit("Incorrect size of file",Id);

                        if      ( ( Fil.Type == SOURCE_FILE )
                        &&        strmatch(Fil.Id,Id) )
                        {
                                if   ( !IncludeFile(Fil.Id) )
                                     ErrorExit("Cannot include file %s",Fil.Id);
                                else
                                     Done = TRUE;
                        }
                }
                while   ( ListPrev(FilList) );

                if      ( !Done && !iswildcard(Id) )
                        ErrorExit("Can't find file %s to include",Id);
        }

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoRunWord(      char    *Line )
{
        if      ( !IsPresent(Line) )
                ErrorExit("No command line found for %s to execute",RUN_WORD);

        RunCommand(Line);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoRdRunWord(    char    *Line )
{
        FILE    *Rd;
static  FName   RdName;
static  char    RdLine[MAX_LINE_LEN+ONE];

        if      ( !IsPresent(Line) )
                ErrorExit("No command line found for %s to execute",RDRUN_WORD);

        tmpnam( RdName );
        /* The '>>' (append) is needed to correctly catch any output from for
           statements - ie '#RDRUN for %%m in (%MOD%) do echo MODULE %%m' */
        strcat( Line, ">> " );
        strcat( Line, RdName );

        RunCommand(Line);

        Rd = fopen(RdName,"r");

        if      ( Rd == NULL )
        {
                if ( Debugging ) printf("Temp file %s not opened\n",RdName);
                remove(RdName);
                return FALSE;
        }

        while   ( fgets(RdLine,MAX_LINE_LEN,Rd) != NULL )
        {
                StripCRLF(RdLine);
                SendFiles(RdLine,TRUE);
        }

        fclose(Rd);
        remove(RdName);

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoMarWord(      char    *Line )
{
        int     NewMargin = atoi(Line);

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no margin value",MAR_WORD);

        if      ( NewMargin < ZERO )
                ErrorExit("Bad margin value: %s",Line);

        MarginSetting = NewMargin;

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoTabWord(      char    *Line )
{
        int     NewTab = atoi(Line);

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no tab value",TAB_WORD);

        if      ( NewTab <= ZERO )
                ErrorExit("Bad tab value: %s",Line);

        TabSetting = NewTab;

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoEmptyWord(    char    *Line )
{
        int     NewEmpty = atoi(Line);

        if      ( !IsPresent(Line) )
                ErrorExit("%s command found no expression",EMPTY_WORD);

        PassEmpty = NewEmpty;

        return  TRUE;
}

/*------------------------------------------------------------------------*/

BOOL    DoSpecial(      char    *Line )
{
        char    *RestOfLine = Line;
        int     Pos = strpos(Line,SPACE);
        BOOL    Active;

        if      ( Pos < ZERO )
                RestOfLine = Line + strlen(Line);
        else
                RestOfLine = StepOverSpaces(RestOfLine+Pos);

        StripTrailChar(RestOfLine,SPACE);

        if ( IsWord(IF_WORD,Line) )     return DoIfWord(RestOfLine);
        if ( IsWord(ELSE_WORD,Line) )   return DoElseWord();
        if ( IsWord(ENDIF_WORD,Line) )  return DoEndIfWord();

        if ( PeekStack(&IFStack,&Active) && !Active ) return TRUE;

        if ( IsWord(DUMP_WORD,Line) )   return DoDumpWord();

        if ( IsWord(VAR_WORD,Line) )    return DoVarWord(RestOfLine);
        if ( IsWord(CFG_WORD,Line) )    return DoCfgWord(RestOfLine);

        if      ( IsWord(FILE_WORD,Line) )
                return DoFileWord(FILE_WORD,OUTPUT_FILE,RestOfLine);

        if      ( IsWord(DATA_WORD,Line) )
                return DoFileWord(DATA_WORD,INPUT_FILE,RestOfLine);

        if      ( IsWord(SRC_WORD,Line) )
                return DoFileWord(SRC_WORD,SOURCE_FILE,RestOfLine);

        if      ( IsWord(SET_WORD,Line) )
                return DoSetWord(RestOfLine);

        if ( IsWord(DEFINE_WORD,Line) ) return DoDefineWord(RestOfLine);
        if ( IsWord(REDEF_WORD,Line) )  return DoReDefWord(RestOfLine);

        if ( IsWord(TAB_WORD,Line) )    return DoTabWord(RestOfLine);
        if ( IsWord(EMPTY_WORD,Line) )  return DoEmptyWord(RestOfLine);
        if ( IsWord(MAR_WORD,Line) )    return DoMarWord(RestOfLine);

        if ( IsWord(SHOW_WORD,Line) )   { ShowSwitches(FALSE); return TRUE; }
        if ( IsWord(ERROR_WORD,Line) )  return DoErrorWord(RestOfLine);
        if ( IsWord(SAY_WORD,Line) )    return DoSayWord(RestOfLine);

        if ( IsWord(SEND_WORD,Line) )   return DoSendWord(RestOfLine);
        if ( IsWord(READ_WORD,Line) )   return DoReadWord(RestOfLine);
        if ( IsWord(INC_WORD,Line) )    return DoIncWord(RestOfLine);
        if ( IsWord(CLOSE_WORD,Line) )  return DoCloseWord(RestOfLine);
        if ( IsWord(DELETE_WORD,Line) ) return DoDeleteWord(RestOfLine);

        if ( IsWord(RUN_WORD,Line) )    return DoRunWord(RestOfLine);
        if ( IsWord(RDRUN_WORD,Line) )  return DoRdRunWord(RestOfLine);

        ErrorExit("Unrecognised special word %s",Line);

        return  FALSE;
}

/* ====================================================================== */

BOOL    IsSpecial(      char    *Text )
{
        char    **NextWord = SpecialWords;
        Tag     Id;

        ExtractNextId(Id,Text);

        while   ( *NextWord != NULL )
                if      ( IsSame(Id,*NextWord) )
                        return  TRUE;
                else
                        NextWord += TWO;

        return  FALSE;
}

/*------------------------------------------------------------------------*/

void    GenerateFiles(  void )
{
static  char    Line[MAX_LINE_LEN+ONE];
static  char    LineBefore[MAX_LINE_LEN+ONE];
        BOOL    Active;

        while   ( GetSrc(Line,MAX_LINE_LEN) != NULL )
        {
                StripCRLF(Line);

                if ( StripComment(Line) ) continue;

                if      ( Tracing )
                {
                        strcpy(LineBefore,Line);
                        printf("Source %s: '%s'\n",CurSrc(),LineBefore);
                }

                strrep(Line,FF,SPACE);
                ExpandEnv(Line);
                ExpandTabs(Line,TabSetting);
                StripTrailChar(Line,SPACE);

                if      ( Tracing && !IsSame(Line,LineBefore) )
                        printf("Expand %s: '%s'\n",CurSrc(),Line);

                if      ( IsSpecial(Line) )
                        DoSpecial(Line);
                else
                if      ( !PeekStack(&IFStack,&Active) || Active )
                        DoNormal(Line,MarginSetting);
        }
}

/* ====================================================================== */

void    DestroyLists(   void )
{
     if ( Debugging ) printf("Destroying lists\n");

     if ( !ListDestroy(&VarList) ) printf("Error: can't destroy switch list\n");
     if ( !ListDestroy(&MacList) ) printf("Error: can't destroy macro list\n");
     if ( !ListDestroy(&CfgList) ) printf("Error: can't destroy config list\n");
     if ( !ListDestroy(&FilList) ) printf("Error: can't destroy file list\n");
     if ( !ListDestroy(&SrcList) ) printf("Error: can't destroy source list\n");

     if ( Debugging ) printf("Lists destroyed\n");
}

/*------------------------------------------------------------------------*/

int     main(           int     argc,
                        char    **argv )
{
        BOOL    Active;

        printf("\n%s\n",PROGNAME);

        GlobArgc = argc,  GlobArgv = argv;

        InitStack(&IFStack);

        strcpy(GlobParams,NILSTR);
        strcpy(GlobSwitches,NILSTR);

        if ( !ListCreate(&VarList) ) ErrorExit("Can't create switch list",NULL);
        if ( !ListCreate(&MacList) ) ErrorExit("Can't create macro list",NULL);
        if ( !ListCreate(&CfgList) ) ErrorExit("Can't create config list",NULL);
        if ( !ListCreate(&FilList) ) ErrorExit("Can't create file list",NULL);
        if ( !ListCreate(&SrcList) ) ErrorExit("Can't create source list",NULL);

        atexit(DestroyLists);

        DoOptions();

        if ( Debugging ) ReportRTS();

        if      ( !OpenSrc(CfgFileName) )
        {
                if      ( argc > ONE )
                        ErrorExit("Cannot find script file '%s'",CfgFileName);

                ShowUsage();
                return EXIT_FAILURE;
        }

        GenerateFiles();

        CloseAllFiles();

        if      ( PeekStack(&IFStack,&Active) )
                ErrorExit("Missing %s at end of source",ENDIF_WORD);

        if ( Debugging ) ReportRTS();

        return  EXIT_SUCCESS;
}

